#include "particle.h"
#include "ofMain.h"


//------------------------------------------------------------
particle::particle(){
	setInitialCondition(0,0,0,0);
	ofEnableAlphaBlending();
	image.loadImage("star1.png");

}

//------------------------------------------------------------
void particle::resetForce(){
	// we reset the forces every frame
	frc.set(0,0);
}

//------------------------------------------------------------
void particle::addForce(float x, float y){
	// add in a force in X and Y for this frame.
	frc.x = frc.x + x;
	frc.y = frc.y + y;
}

//------------------------------------------------------------
void particle::addDampingForce(){
	
	// the usual way to write this is  vel *= 0.99
	// basically, subtract some part of the velocity 
	// damping is a force operating in the oposite direction of the 
	// velocity vector
	
	frc.x = frc.x - vel.x * damping;
	frc.y = frc.y - vel.y * damping;
}

//------------------------------------------------------------
void particle::setInitialCondition(float px, float py, float vx, float vy){
	pos.set(px,py);
	vel.set(vx,vy);
}

//------------------------------------------------------------
void particle::update(){	
	vel = vel + frc;
	pos = pos + vel;
}

//------------------------------------------------------------
void particle::draw(){
	ofSetColor(color.r, color.g, color.b, color.a);
	image.draw(pos.x, pos.y);

}

void particle::setColor(ofColor& c) {
	color = c;
}

void particle::setAlpha(int alpha) {
	color.a = alpha;	
}